//Provided by Grotius d.d. 9-6-2019
//GPL2

//PROGRAM PURPOSE :
//QT OpenGL example how to draw a horizontal line by clicking a button in a custom QT C++ gui.
//
//PROGRAM INFO :
//2. glOrtho(-10, 10, -10, 10, -1.0, 3.5);          (changing this value's will provide zoom in and zoom out function's)
//3. auto dv = new QDoubleValidator(0.0, 5.0, 2);   (will result that the text entry box can only be used for typing in float value's instead of characters)
//4. compatible with the latest OpenGLWidget, compatible with QT version 5.12.2
//5. have fun to expand this code to your needs, and give code back once in a while, that is what GPL2 is all about.

#include "mainwindow.h"
#include "ui_mainwindow.h"
#include "oglwidget.h"
#include <QDebug>
#include <QString>
#include <stdio.h>
#include <QWidget>
#include <QOpenGLWidget>
#include <QtOpenGL>

#include <QWheelEvent>
#include <QListView>

//#include <QMessageBox>
#include <dialog.h>
#include <help.h>
#include <licence.h>
#include <open.h>
#include <save.h>
#include <about.h>
#include <rectangular.h>
#include <open_dxf.h>

//#include <QMenuBar>


int z = 5;


MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);

    //ui->actionAbout_4->setText(QString "test")SIGNAL(triggered()), qApp, SLOT();


 //@connect( ui -> some_action, SIGNAL(triggered()), qApp, SLOT(some slot))@

}


MainWindow::~MainWindow()
{
    delete ui;
}



void MainWindow::on_pushButton_clicked()
{
    float feedrate = ui->lineEdit_2->text().toFloat();
    float power = ui->lineEdit_3->text().toFloat();
    float kerf = ui->lineEdit_5->text().toFloat();
    leadin = ui->lineEdit_6->text().toFloat();
    circlediameter = ui->lineEdit_7->text().toFloat();
    circle_x_center = ui->lineEdit_8->text().toFloat();
    circle_y_center = ui->lineEdit_9->text().toFloat();

    linewidth = ui->lineEdit->text().toFloat();            //the text input label is a text, but we convert it directly to float.
    lineheight = ui->lineEdit_4->text().toFloat();
    qDebug() << linewidth << lineheight;                                 //print the output in the console.

    ui->plainTextEdit_3->appendPlainText("(postprocessor for linuxcnc plasma)\nG21 (Metric)\nG40 G90 G64P0.01\nF1 S1\n");

    //ui->plainTextEdit_3->setFont(QFont ("Arial", 10));
    //g-code inside contour circle:
    ui->plainTextEdit_3->appendPlainText("Inside offset ccw");

    //QPalette blue = ui->plainTextEdit_3->palette();
    //ui->plainTextEdit_3->setPalette(blue);
    //blue.setColor(QPalette::Text, Qt::blue);

    //apply kerf offset:
    ui->plainTextEdit_3->appendPlainText("G41 D" + QString::number(kerf/2));   //G41 is left side off path
    //go to centerpoint of circle:
    ui->plainTextEdit_3->appendPlainText("G0 X" + QString::number(circle_x_center) + " Y" + QString::number(circle_y_center) );
    //start torch:
    ui->plainTextEdit_3->appendPlainText("M3");
    //cut circle ccw:
    ui->plainTextEdit_3->appendPlainText("G3 I and J values look at your existing C-code files for lead in....");
    ui->plainTextEdit_3->appendPlainText("M5");
    //reset kerf width offsets:
    ui->plainTextEdit_3->appendPlainText("G40\n");



    //g-code outside contour rectangular:
    ui->plainTextEdit_3->appendPlainText("Outside offset cw");
    //ui->plainTextEdit_3->setPalette(white);
    //apply kerf offset:
    ui->plainTextEdit_3->appendPlainText("G41 D" + QString::number(kerf/2));
    //Lead in:
    ui->plainTextEdit_3->appendPlainText("G0 X" + QString::number(leadin*-1) + " Y" + QString::number(leadin*-1));
    //Goto start point at travelheight:
    ui->plainTextEdit_3->appendPlainText("G0 X0 Y0");
    //Goto cutheight and wait for arc-ok:
    ui->plainTextEdit_3->appendPlainText("M3 S" + QString::number(power));
    //Must change direction from G42 to G41....
    QString str1 = "G1 X" + QString::number(linewidth) + " Y0" + " F" + QString::number(feedrate);
    ui->plainTextEdit_3->appendPlainText(str1);

    QString str2 = "X" + QString::number(linewidth) + " Y" + QString::number(lineheight);
    ui->plainTextEdit_3->appendPlainText(str2);

    QString str3 = "X0 Y" + QString::number(lineheight);
    ui->plainTextEdit_3->appendPlainText(str3);

    ui->plainTextEdit_3->appendPlainText("X0 Y0");
    ui->plainTextEdit_3->appendPlainText("G40");
    ui->plainTextEdit_3->appendPlainText("M5");
    ui->plainTextEdit_3->appendPlainText("M30");

}

void MainWindow::on_lineEdit_textEdited(const QString &arg1)
{
    auto dv = new QDoubleValidator(0.0, 5.0, 2);            // set the text entry label valid for float input only, [0, 5] with 2 decimals of precision
    ui->lineEdit->setValidator(dv);
}

void MainWindow::on_help_triggered()
{
    Help dialog;
    dialog.setModal(true);
    dialog.exec();
}

void MainWindow::on_licence_triggered()
{
    Licence dialog;
    dialog.setModal(true);
    dialog.exec();
}

void MainWindow::on_save_triggered()
{
    Save dialog;
    dialog.setModal(true);
    dialog.exec();
}

void MainWindow::on_exit_triggered()
{
    QApplication::quit();
}

void MainWindow::on_about_triggered()
{
    // at the top of the mainwindow : #include <about.h>
    About dialog;
    dialog.setModal(true);
    dialog.exec();
}

void MainWindow::on_open_2_triggered()
{
    Open dialog;
    dialog.setModal(true);
    dialog.exec();
}
