#include "oglwidget.h"
#include "mainwindow.h"
#include <QDebug>
#include <QString>
#include <stdio.h>
#include <GL/glu.h>

OGLWidget::OGLWidget(QWidget *parent)
    : QOpenGLWidget(parent)
{

}

OGLWidget::~OGLWidget()
{

}

void OGLWidget::initializeGL()
{
    glClearColor(0,0,0,1);
    glEnable(GL_DEPTH_TEST);
    glEnable(GL_LIGHT0);
    glEnable(GL_LIGHTING);
    glColorMaterial(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE);
    glEnable(GL_COLOR_MATERIAL);
}

void OGLWidget::paintGL()
{
    // update the line drawing on the screen.
    QTimer *timer = new QTimer(this);
    connect(timer, SIGNAL(timeout()), this, SLOT(update()));
    timer->start(10);                                       //start(1000) is update the screen every 1000ms or 1 seconde.
    // end timer function

    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    glBegin(GL_LINES);

    //the horizontal red line that appear's in the screen :
    glColor3f(1.0f, 0.0f, 0.0f);
    glVertex2f(0.0f, 0.0f);
    glVertex2f(linelenght, 0.0f);                            //linelenght is the example of the global variable, the value is set in the mainwindow.ccp => void MainWindow::on_pushButton_clicked().
    glEnd();

}

void OGLWidget::resizeGL(int w, int h)
{
    glViewport(0,0,w,h);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();

    glOrtho(-10, 10, -10, 10, -1.0, 3.5);                   //glOrtho is for zoom in and zoom out.

    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
}
