#include "open.h"
#include "ui_open.h"
#include <QString>
#include <QDebug>
#include <QModelIndex>

// for old c code we add some libraries
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

QString sPath; //directory
QString fPath; //directory + filename + extension


int x_start;                 //10
int y_start;                 //20
int z_start;                 //30
int x_end;                   //11
int y_end;                   //21
int z_end;                   //31
int linenumber = 1;          //Avoid starting with linenumber 0
int linetrigger;             //LINE
int lineblock;               //every line has one lineblock, that block holds values : x_start to z_end.
int x_center;                //10
int y_center;                //20
int z_center;                //30
int radius;                  //40
int start_angle;             //50    degrees 0=horizontal right, 90=vertical up, 180=horizontal left, 270=vertical down
int end_angle;               //51    degrees comment as above
int end;                     //0     end of circle section (2 empty spaces)
int circletrigger;           //CIRCLE
int circlesubtrigger;        //sub AcDbEntity, includes circle layer
int circleblock;
int arctrigger;              //ARC
int arcsubtrigger;
int arcblock;
int x_float_collector;       //All items declared in circle section are also used for arc section.
int y_float_collector;
int z_float_collector;
int radius_float_collector;
float temp_x_center;
float temp_y_center;
float temp_z_center;
float temp_radius;
float temp_start_angle;      //for arc's, calculation and conversion to g-code todo
float temp_end_angle;
int start_angle_float_collector;
int end_angle_float_collector;
int poly_x_point;            //10
int poly_y_point;            //20
int polytrigger;             //LWPOLYLINE
int polysubtrigger;
int polyblock;
int polyitem;                //value of separete lines inside of polyblock
//char count[100];             // hold's the string of one text file line

QString line;


Open::Open(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::Open)
{
    ui->setupUi(this);
    //setup the header file first..
    QString sPath = "C:/";
    dirmodel = new QFileSystemModel(this);
    dirmodel->setRootPath(sPath);
    dirmodel->setFilter(QDir::NoDotAndDotDot | QDir::AllDirs);
    ui->dirview->setModel(dirmodel);
    ui->dirview->hideColumn(1);
    ui->dirview->hideColumn(2);
    ui->dirview->hideColumn(3);

    filemodel = new QFileSystemModel(this);
    filemodel->setFilter(QDir::NoDotAndDotDot | QDir::Files);
    ui->fileview->setModel(filemodel);
    ui->fileview->hideColumn(1);
    ui->fileview->hideColumn(2);
    ui->fileview->hideColumn(3);

}

Open::~Open()
{
    delete ui;
}

void Open::on_buttonBox_rejected()
{
    this->close();
}

void Open::on_buttonBox_accepted()
{

    // Open file to read
    QFile file_in(fPath);
    if(!file_in.open(QIODevice::ReadOnly)) {
        qDebug() << "error reading file" << file_in.errorString();
    }

    // Open file to write
    QString userfilename = sPath;                   // directory path
    userfilename += "/";
    userfilename += ui->lineEdit->text();           // ui input field
    qDebug() << userfilename;

    QFile file_out( userfilename );
    if(file_out.open(QIODevice::ReadWrite)){

    // Make file stream connections
    QTextStream in(&file_in);                       // file to read
    QTextStream out(&file_out);                     // file to write

    // Read file line by line
    while(!in.atEnd()) {
        QString line = in.readLine();
        //QString searchString = "LINE";

        ui->data_in->appendPlainText(line);

       // Search for "LINE", the ! means exclude this...
       if(line.contains("LINE", Qt::CaseSensitive) && (!line.contains("LWPOLYLINE", Qt::CaseSensitive)) && (!line.contains("$PLINEWID", Qt::CaseSensitive)) &&
               (!line.contains("$SPLINETYPE", Qt::CaseSensitive)) && (!line.contains("$SPLINESEGS", Qt::CaseSensitive)) && (!line.contains("$PLINEGEN", Qt::CaseSensitive)) &&
               (!line.contains("ACAD_MLINESTYLE", Qt::CaseSensitive)) && (!line.contains("MLINESTYLE", Qt::CaseSensitive))
               ){
            out << "LINE is found at linenumber :" << linenumber << endl;               // Write the linenumber where LINE is found to file
            qDebug() << "found at linenumber :" << linenumber;
            ui->data_out->appendPlainText("LINE is found at line : " + QString::number(linenumber));   // Write the linenumber where LINE is found to the ui

            linetrigger = 1;

       }

       if ((linetrigger == 1) && (line.contains(" 10", Qt::CaseSensitive))){
           //qDebug() << "10 found at linenumber: " << linenumber;
           x_start = linenumber + 2;  //set your linenumber for x_start, _10 is found, the value we search for is one line below 10.
       }

       if ((linetrigger == 1) && (line.contains("  0", Qt::CaseSensitive))){
           linetrigger = 0;                         // use this to finish your search after "LINE" is triggered.
       }

            linenumber ++;                          // Increase the linenumber with value 1
            //float linebuffer = line.toFloat();      // Converse string to float

       // Write line to file
       if (linetrigger == 1){
            if (linenumber == x_start){
                 ui->data_out->appendPlainText("the value x_start value : " + line);     // write to screen ui
                 out << " value is " << line << endl;
            }
       }

    }}
    file_in.close();
    file_out.close();
}



void Open::on_dirview_clicked(const QModelIndex &index)
{
    //https://www.youtube.com/watch?v=92biLZST6Vg
    sPath = dirmodel->fileInfo(index).absoluteFilePath();
    ui->fileview->setRootIndex(filemodel->setRootPath(sPath));
    qDebug() << sPath;

}

void Open::on_fileview_clicked(const QModelIndex &index)
{
    fPath = filemodel->fileInfo(index).absoluteFilePath();
    //ui->fileview->setRootIndex(filemodel->setRootPath(fPath));
    qDebug() << fPath;
}
