#ifndef OPEN_H
#define OPEN_H

#include <QDialog>
#include <QFileSystemModel>

extern QString sPath;
extern QString fPath;
extern QString line;

extern int x_start;                 //10
extern int y_start;                 //20
extern int z_start;                 //30
extern int x_end;                   //11
extern int y_end;                   //21
extern int z_end;                   //31
extern int linenumber;
extern int linetrigger;             //LINE
extern int lineblock;               //every line has one lineblock, that block holds values : x_start to z_end.
extern int x_center;                //10
extern int y_center;                //20
extern int z_center;                //30
extern int radius;                  //40
extern int start_angle;             //50    degrees 0=horizontal right, 90=vertical up, 180=horizontal left, 270=vertical down
extern int end_angle;               //51    degrees comment as above
extern int end;                     //0     end of circle section (2 empty spaces)
extern int circletrigger;           //CIRCLE
extern int circlesubtrigger;        //sub AcDbEntity, includes circle layer
extern int circleblock;
extern int arctrigger;              //ARC
extern int arcsubtrigger;
extern int arcblock;
extern int x_float_collector;       //All items declared in circle section are also used for arc section.
extern int y_float_collector;
extern int z_float_collector;
extern int radius_float_collector;
extern float temp_x_center;
extern float temp_y_center;
extern float temp_z_center;
extern float temp_radius;
extern float temp_start_angle;      //for arc's, calculation and conversion to g-code todo
extern float temp_end_angle;
extern int start_angle_float_collector;
extern int end_angle_float_collector;
extern int poly_x_point;            //10
extern int poly_y_point;            //20
extern int polytrigger;             //LWPOLYLINE
extern int polysubtrigger;
extern int polyblock;
extern int polyitem;                //value of separete lines inside of polyblock
//extern char count[100];             // hold's the string of one text file line

namespace Ui {
class Open;
}

class Open : public QDialog
{
    Q_OBJECT

public:
    explicit Open(QWidget *parent = nullptr);
    ~Open();

private slots:
    void on_buttonBox_rejected();

    void on_buttonBox_accepted();

    void on_dirview_clicked(const QModelIndex &index);

    void on_fileview_clicked(const QModelIndex &index);

private:
    Ui::Open *ui;
    QFileSystemModel *dirmodel;
    QFileSystemModel *filemodel;
};

#endif // OPEN_H
