#include "open_dxf.h"
#include "ui_open_dxf.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

//line section :           //LINE
int x_start;               //10
int y_start;               //20
int z_start;	           //30
int x_end;                 //11
int y_end;                 //21
int z_end;	               //31
int linenumber = 0;
int linetrigger = 0;       //LINE
int lineblock = 0;         // every line has one lineblock, that block holds values : x_start to z_end.

//circle section :         //CIRCLE || ARC  subword : AcDbEntity, includes circle layer
int x_center;              //10
int y_center;              //20
int z_center;              //30
int radius;                //40
int start_angle;           //50  degrees 0=horizontal right, 90=vertical up, 180=horizontal left, 270=vertical down
int end_angle;             //51  degrees comment as above
int end;                   //  0 end of circle section (2 empty spaces)
int circletrigger = 0;     //CIRCLE
int circlesubtrigger = 0;  //sub AcDbEntity, includes circle layer
int circleblock = 0;

int arctrigger = 0;        //ARC
int arcsubtrigger = 0;
int arcblock = 0;

//circle section, collect all data of one circle block first, after that print g-code line. This is done this way to calculate circle startpoint.
int x_float_collector = 0; //All items declared in circle section are also used for arc section.
int y_float_collector = 0;
int z_float_collector = 0;
int radius_float_collector = 0;
float temp_x_center;
float temp_y_center;
float temp_z_center;
float temp_radius;

// Visualisation how dxf circles are defined :
//
//              90 Y-Axis
//               | Circle J value (g-code vertical)
//               |
//               |
//               |
//  180__________|x_center______ 0   X-Axis
//  (S)          |y_center       360 Circle I value (g-code horizontal)
//               |
//               |
//               |
//               |
//              270
//
//  At (S) we program our startpoint for g-code, we start with G02 circle command's
//  For g-code we use the x_center and y_center, this correspondents to the dxf file values 10 and 20
//  For I in g-code we calculate : radius*-1 => This will set our circle startpoint from center to the (S)
//  Later on we do lead in's and edit startpoints.

//arc section :
float temp_start_angle;    //for arc's, calculation and conversion to g-code todo
float temp_end_angle;
int start_angle_float_collector = 0;
int end_angle_float_collector = 0;

// Visualisation how dxf arc's are defined :
//
//              90 Y-Axis
//               |
//       **      |      *
//               |
//               |
//  180__________|x_center______ 0   X-Axis
//               |y_center       360
//               |
//               |
//       ***     |      ****
//               |
//              270
//
//  *    = start_angle = 0   up to end_angle = 90
//  **   = start_angle = 90  up to end_angle = 180
//  ***  = start_angle = 180 up to end_angle = 270
//  **** = start_angle = 270 up toend_angle = 360

//polygon section :        //LWPOLYLINE  //Do a autocad list commando to check parameters.
int poly_x_point;          //10
int poly_y_point;          //20
int polytrigger = 0;       //LWPOLYLINE
int polysubtrigger = 0;
int polyblock = 0;
int polyitem  = 0;         //value of separete lines inside of polyblock

//int layer;                 //8

char count[100]={0x0};     // hold's the string of one text file line

// int write_stop = 0;
// int printlinenumber = 0;


Open_dxf::Open_dxf(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::Open_dxf)
{
    ui->setupUi(this);
}

Open_dxf::~Open_dxf()
{
    delete ui;
}

void Open_dxf::on_buttonBox_accepted()
{


}

void Open_dxf::on_buttonBox_rejected()
{
    this->close();
}
