#include "rectangular.h"
#include "ui_rectangular.h"
#include <QString>
#include <QDebug>

/*
    dxf line codes :
    int x_start;               //10
    int y_start;               //20
    int z_start;	           //30
    int x_end;                 //11
    int y_end;                 //21
    int z_end;	               //31
*/

Rectangular::Rectangular(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::Rectangular)
{
    ui->setupUi(this);
}

Rectangular::~Rectangular()
{
    delete ui;
}

void Rectangular::on_cancel_ok_accepted()
{

//GCODE LOGIC:
    ui->plainTextEdit->appendPlainText("(Grotius .GRO file)");
    qDebug() << "ok pressed";

    //make the g-code formulas over here:

    //qDebug() << ui->width->text() << ui->height->text();

    // begin g-code
    ui->plainTextEdit->appendPlainText("(Begin rectangular object)");
    // we start in G40 mode // later this week we add cw and ccw options to the code related to the combobox user input.
    //G41 <D-> (left of programmed path)
    //G42 <D-> (right of programmed path)

    ui->plainTextEdit->appendPlainText("G40");
    // for now the zero point
    ui->plainTextEdit->appendPlainText("G00 X0 Y0");

    // DXF logic zero point : LINE, x start trigger, x start value, y start trigger, y start value
    ui->plainTextEdit->appendPlainText("(LINE, 10, 0, 20, 0)");

    // start torch with a certain power
    ui->plainTextEdit->appendPlainText("M3 S" + ui->power->text());

    // move x+
    ui->plainTextEdit->appendPlainText("G01 X" + ui->width->text() + " Y0" + " F" + ui->feedrate->text());
    // DXF logic move x+ :
    ui->plainTextEdit->appendPlainText("(LINE, 11, "+ ui->width->text() + ", 21, 0)");

    // move y+
    ui->plainTextEdit->appendPlainText("G01 X" + ui->width->text() + " Y" + ui->height->text());
    // DXF logic y+ :
    ui->plainTextEdit->appendPlainText("(LINE, 11, "+ ui->width->text() + ", 21, " + ui->height->text() + ")");

    // move x-
    ui->plainTextEdit->appendPlainText("G01 X0 Y" + ui->height->text());
    // DXF logic x- :
    ui->plainTextEdit->appendPlainText("(LINE, 11, 0, 21, " + ui->height->text() + ")");

    // move y-
    ui->plainTextEdit->appendPlainText("G01 X0 Y0");
    // DXF logic y- :
    ui->plainTextEdit->appendPlainText("(LINE, 11, 0, 21, 0)");

    // stop torch
    ui->plainTextEdit->appendPlainText("M5");
    // end g-gode
    ui->plainTextEdit->appendPlainText("(End rectangular object)");













}

void Rectangular::on_cancel_ok_rejected()
{
    this->close();
}


